#!/usr/bin/env python3
import argparse
from math import sqrt

def parse_args():
    parser = argparse.ArgumentParser()
    parser.add_argument('data')
    return vars(parser.parse_args())

if __name__ == '__main__':
    args = parse_args()

    with open(args['data'], 'rt') as f_in, open(args['data']+'.no', 'wt') as f_out:
        for line in f_in:
            try:
                y, x = line.rstrip().split(maxsplit=1)
            except:
                f_out.write(line)
                continue
            norm = 0
            for node in x.split():
                idx, val = node.split(sep=':')
                norm += float(val)**2
            norm = sqrt(norm)

            for node in x.split():
                idx, val = node.split(sep=':')
                v = float(val)/norm
                y += ' {idx}:{val:.6f}'.format(idx=idx, val=v)
            f_out.write(y+'\n')
